;;; skk/leim-list.el --- list of LEIM for SKK  -*- emacs-lisp -*-

;; Copyright (C) 2000 SKK Development Team <skk@ring.gr.jp>

;; Maintainer: SKK Development Team <skk@ring.gr.jp>
;; Keywords: japanese, mule, input method

;; This file is part of Daredevil SKK.

;; This program is free software: you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as
;; published by the Free Software Foundation, either version 3 of
;; the License, or (at your option) any later version.

;; This program is distributed in the hope that it will be
;; useful, but WITHOUT ANY WARRANTY; without even the implied
;; warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
;; PURPOSE.  See the GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

;;; Commentary:

;; This file registers SKK as input methods for Emacs.
;; Currently this file is for FSF Emacs only (not for XEmacs).

;;; Code:

(unless noninteractive
  ;; No need to load this file when Emacs is called for `make' or most of other
  ;; batch processings.

  ;; `register-input-method' is called in skk-autoloads.el.  `skk-activate' is
  ;; also autoloaded there.
  (require 'skk-autoloads)

  ;; Doubt.  This is a matter of preference.
  (require 'skk-setup))

;; Local Variables:
;; indent-tabs-mode: nil
;; End:

;;; skk/leim-list.el ends here
